(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-class-component')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue-class-component'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueClassDecorator = {}, global.VueClassComponent));
}(this, (function (exports, vueClassComponent) { 'use strict';

    function Prop(options) {
        if (options === void 0) { options = {}; }
        return function (target, key) {
            vueClassComponent.createDecorator(function (componentOptions, propName) {
                (componentOptions.props || (componentOptions.props = {}))[propName] = options;
            })(target, key);
        };
    }

    function Watch(path, options) {
        if (options === void 0) { options = {}; }
        var _a = options.deep, deep = _a === void 0 ? false : _a, _b = options.immediate, immediate = _b === void 0 ? false : _b;
        return vueClassComponent.createDecorator(function (componentOptions, handler) {
            if (typeof componentOptions.watch !== 'object') {
                componentOptions.watch = Object.create(null);
            }
            var watch = componentOptions.watch;
            if (typeof watch[path] === 'object' && !Array.isArray(watch[path])) {
                watch[path] = [watch[path]];
            }
            else if (typeof watch[path] === 'undefined') {
                watch[path] = [];
            }
            watch[path].push({ handler: handler, deep: deep, immediate: immediate });
        });
    }

    Object.defineProperty(exports, 'Options', {
        enumerable: true,
        get: function () {
            return vueClassComponent.Options;
        }
    });
    Object.defineProperty(exports, 'Vue', {
        enumerable: true,
        get: function () {
            return vueClassComponent.Vue;
        }
    });
    exports.Prop = Prop;
    exports.Watch = Watch;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
